



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LINQ to SQL Select查询</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LINQ to SQL Select查询</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 03:39:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1. 查询所有字段</h1>
<div>
<pre class="prettyprint linenums">  using (NorthwindEntities context = new NorthwindEntities())
            {
                var order = from n in context.Orders select n;
                foreach (var i in order.ToList())
                {
                    Console.Write(i.Customers);
                    Console.WriteLine();
                }
            }</pre>
</div>
<p><strong>生成SQL语句为：</strong></p>
<div>
<pre class="prettyprint linenums">SELECT
    [Extent1].[OrderID] AS [OrderID],
    [Extent1].[CustomerID] AS [CustomerID],
    [Extent1].[EmployeeID] AS [EmployeeID],
    [Extent1].[OrderDate] AS [OrderDate],
    [Extent1].[RequiredDate] AS [RequiredDate],
    [Extent1].[ShippedDate] AS [ShippedDate],
    [Extent1].[ShipVia] AS [ShipVia],
    [Extent1].[Freight] AS [Freight],
    [Extent1].[ShipName] AS [ShipName],
    [Extent1].[ShipAddress] AS [ShipAddress],
    [Extent1].[ShipCity] AS [ShipCity],
    [Extent1].[ShipRegion] AS [ShipRegion],
    [Extent1].[ShipPostalCode] AS [ShipPostalCode],
    [Extent1].[ShipCountry] AS [ShipCountry]
    FROM [dbo].[Orders] AS [Extent1]</pre>
</div>
<h1><strong>&nbsp;</strong>2. 指定字段查询</h1>
<div>
<pre class="prettyprint linenums">var product = from n in context.Products
                    .Select(p =&gt; new { p.CategoryID, p.ProductName })
                    select n;</pre>
</div>
<p>也可以是：</p>
<div>
<pre class="prettyprint linenums">  var product = context.Products.Select(p =&gt; new { p.CategoryID, p.ProductName });</pre>
</div>
<p><strong>&nbsp;生成SQL语句为：</strong></p>
<div>
<pre class="prettyprint linenums">SELECT
     AS [C1],
    [Extent1].[CategoryID] AS [CategoryID],
    [Extent1].[ProductName] AS [ProductName]
    FROM [dbo].[Products] AS [Extent1]</pre>
</div>
<h1><strong>3.&nbsp;First和FirstOrDefault</strong></h1>
<div>
<pre class="prettyprint linenums"> var product = context.Products.FirstOrDefault();</pre>
</div>
<div>
<pre class="prettyprint linenums"> var product = context.Products.First();</pre>
</div>
<p><strong>生成SQL语句为：</strong></p>
<div>
<pre class="prettyprint linenums">)
    [c].[ProductID] AS [ProductID],
    [c].[ProductName] AS [ProductName],
    [c].[SupplierID] AS [SupplierID],
    [c].[CategoryID] AS [CategoryID],
    [c].[QuantityPerUnit] AS [QuantityPerUnit],
    [c].[UnitPrice] AS [UnitPrice],
    [c].[UnitsInStock] AS [UnitsInStock],
    [c].[UnitsOnOrder] AS [UnitsOnOrder],
    [c].[ReorderLevel] AS [ReorderLevel],
    [c].[Discontinued] AS [Discontinued]
    FROM [dbo].[Products] AS [c]</pre>
</div>
<h1>4.&nbsp;Single和SingleOrDefault</h1>
<div>
<pre class="prettyprint linenums">var product = context.Products.Single(p =&gt; p.ProductID==1);</pre>
</div>
<div>
<pre class="prettyprint linenums">var product = context.Products.SingleOrDefault(p =&gt; p.ProductID==1);</pre>
</div>
<p>生成的SQL语句为：</p>
<div>
<pre class="prettyprint linenums">)
    [Extent1].[ProductID] AS [ProductID],
    [Extent1].[ProductName] AS [ProductName],
    [Extent1].[SupplierID] AS [SupplierID],
    [Extent1].[CategoryID] AS [CategoryID],
    [Extent1].[QuantityPerUnit] AS [QuantityPerUnit],
    [Extent1].[UnitPrice] AS [UnitPrice],
    [Extent1].[UnitsInStock] AS [UnitsInStock],
    [Extent1].[UnitsOnOrder] AS [UnitsOnOrder],
    [Extent1].[ReorderLevel] AS [ReorderLevel],
    [Extent1].[Discontinued] AS [Discontinued]
    FROM [dbo].[Products] AS [Extent1]
     = [Extent1].[ProductID]</pre>
</div>
<h1>5.First,FirstOrDefault,Single,SingleOrDefault的区别</h1>
<p><strong>区别：</strong></p>
<p>First：取序列中满足条件的第一个元素，如果没有元素满足条件，则抛出异常。</p>
<p>FirstOrDefault：取序列中满足条件的第一个元素，如果没有元素满足条件，则返回默认值（对于可以为null的对象，默认值为null，对于不能为null的对象，如int，默认值为0）。</p>
<p>Single：返回序列中的唯一一条记录，如果没有或返回多条，则引发异常。</p>
<p>SingleOrDefault：返回序列中的唯一一条记录，如果序列中不包含任何记录，则返回默认值，如果返回多条，则引发异常。</p>
<p><strong>使用场景：</strong></p>
<p>当没有元素满足条件时，First会抛出异常，FirstOrDefault会返回默认值。</p>
<p>1. First当确信有元素满足条件时，使用First方法。取到元素后，无需判断是否为null。</p>
<p>2. 当不确信或序列中找不到满足条件的元素时，使用FirstOrDefault方法。然后一定要对返回值进行判断是否为null，进行不同的处理</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zdv19.html">iOS开发之如何跳到系统设置里的各种设置界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnvg2x8.html">SSRS3： Credentials配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdnry79.html">Mustache&period;js前端模板引擎源码解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wj44wq.html">Javascript中最常用的61段经典代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x050e8.html">C&num;中的static、readonly与const的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnp52pq.html">Windows 命令大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j06xleq.html">android自定义样式大全：shape&comma;selector&comma;layer-list，style&comma;动画全部内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3v2z8.html">自定义seekbar中，thumb被覆盖掉一部分问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mp1jxq.html">&sol;etc&sol;ld&period;so&period;conf详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjmlwk8.html">iOS Development&colon; Proper Use of initWithNibName&colon;bundle&colon; Affects UITableViewController</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gepgg48.html">用Python做SVD文档聚类---奇异值分解----文档相似性----LSI（潜在语义分析）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1v602q.html">CNN－梯度下降</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoklx3q.html">WebStorm和IntelliJIEDA软件注册码网站（手动填写）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8melle0q.html">JAVA基础--工厂模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjrr338.html">通过winform&plus;模拟登录实现快速一键登录到人才招聘网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjw1v28.html">Vue&period;js 介绍入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z37dk9.html">sql server 2008 r2 数据库操作时提示 9002错误&OpenCurlyDoubleQuote;事物日志已满&rdquo;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljymrx9.html">GXOI&sol;GZOI2019题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ozpn18.html">Django的MVT模式与MVC模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25gdrxq.html">由装饰者模式来深入理解Java I&sol;O整体框架</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/6e9pmz9x.html">Markdown 图片助手-MarkdownPicPicker</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ok5p9z.html">async &amp;amp&semi; await 的前世今生（Updated）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m960j494.html">协议森林16 小美的桌号（DHCP协议）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwdy8x.html">MVC常遇见的几个场景代码分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyyjjqr.html">套用JQuery EasyUI列表显示数据、分页、查询</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o415qz.html">玩转spring boot&mdash;&mdash;结合redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rn57q0.html">玩转spring boot&mdash;&mdash;结合JPA入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zj7n9y.html">A&sol;B Testing的简要知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j2p485.html">自制Azure中国版&OpenCurlyDoubleQuote;加血包&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jl24q5.html">我将系统从Windows迁移至Linux下的点点滴滴</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
